
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Pango.Objects.EngineShape
    ( 

-- * Exported types
    EngineShape(..)                         ,
    EngineShapeK                            ,
    toEngineShape                           ,
    noEngineShape                           ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks
import qualified GI.GObject as GObject

newtype EngineShape = EngineShape (ForeignPtr EngineShape)
foreign import ccall "pango_engine_shape_get_type"
    c_pango_engine_shape_get_type :: IO GType

type instance ParentTypes EngineShape = EngineShapeParentTypes
type EngineShapeParentTypes = '[Engine, GObject.Object]

instance GObject EngineShape where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_pango_engine_shape_get_type
    

class GObject o => EngineShapeK o
instance (GObject o, IsDescendantOf EngineShape o) => EngineShapeK o

toEngineShape :: EngineShapeK o => o -> IO EngineShape
toEngineShape = unsafeCastTo EngineShape

noEngineShape :: Maybe EngineShape
noEngineShape = Nothing

type instance AttributeList EngineShape = EngineShapeAttributeList
type EngineShapeAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList EngineShape = EngineShapeSignalList
type EngineShapeSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


