
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

The #PangoAttrFloat structure is used to represent attributes with
a float or double value.
-}

module GI.Pango.Structs.AttrFloat
    ( 

-- * Exported types
    AttrFloat(..)                           ,
    noAttrFloat                             ,


 -- * Properties
-- ** Attr
    attrFloatReadAttr                       ,


-- ** Value
    attrFloatReadValue                      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks

newtype AttrFloat = AttrFloat (ForeignPtr AttrFloat)
noAttrFloat :: Maybe AttrFloat
noAttrFloat = Nothing

attrFloatReadAttr :: AttrFloat -> IO Attribute
attrFloatReadAttr s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr Attribute)
    val' <- (newPtr 16 Attribute) val
    return val'

attrFloatReadValue :: AttrFloat -> IO Double
attrFloatReadValue s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CDouble
    let val' = realToFrac val
    return val'


