
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

The #PangoAttrFontFeatures structure is used to represent OpenType
font features as an attribute.
-}

module GI.Pango.Structs.AttrFontFeatures
    ( 

-- * Exported types
    AttrFontFeatures(..)                    ,
    noAttrFontFeatures                      ,


 -- * Properties
-- ** Attr
    attrFontFeaturesReadAttr                ,


-- ** Features
    attrFontFeaturesReadFeatures            ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks

newtype AttrFontFeatures = AttrFontFeatures (ForeignPtr AttrFontFeatures)
noAttrFontFeatures :: Maybe AttrFontFeatures
noAttrFontFeatures = Nothing

attrFontFeaturesReadAttr :: AttrFontFeatures -> IO Attribute
attrFontFeaturesReadAttr s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr Attribute)
    val' <- (newPtr 16 Attribute) val
    return val'

attrFontFeaturesReadFeatures :: AttrFontFeatures -> IO T.Text
attrFontFeaturesReadFeatures s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    val' <- cstringToText val
    return val'


