
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

The #PangoEngineInfo structure contains information about a particular
engine. It contains the following fields:
-}

module GI.Pango.Structs.EngineInfo
    ( 

-- * Exported types
    EngineInfo(..)                          ,
    noEngineInfo                            ,


 -- * Properties
-- ** EngineType
    engineInfoReadEngineType                ,


-- ** Id
    engineInfoReadId                        ,


-- ** NScripts
    engineInfoReadNScripts                  ,


-- ** RenderType
    engineInfoReadRenderType                ,


-- ** Scripts
    engineInfoReadScripts                   ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks

newtype EngineInfo = EngineInfo (ForeignPtr EngineInfo)
noEngineInfo :: Maybe EngineInfo
noEngineInfo = Nothing

engineInfoReadId :: EngineInfo -> IO T.Text
engineInfoReadId s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CString
    val' <- cstringToText val
    return val'

engineInfoReadEngineType :: EngineInfo -> IO T.Text
engineInfoReadEngineType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    val' <- cstringToText val
    return val'

engineInfoReadRenderType :: EngineInfo -> IO T.Text
engineInfoReadRenderType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    val' <- cstringToText val
    return val'

engineInfoReadScripts :: EngineInfo -> IO EngineScriptInfo
engineInfoReadScripts s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO (Ptr EngineScriptInfo)
    val' <- (newPtr 16 EngineScriptInfo) val
    return val'

engineInfoReadNScripts :: EngineInfo -> IO Int32
engineInfoReadNScripts s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 32) :: IO Int32
    return val


