
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

The PangoGlyphVisAttr is used to communicate information between
the shaping phase and the rendering phase.  More attributes may be
added in the future.
-}

module GI.Pango.Structs.GlyphVisAttr
    ( 

-- * Exported types
    GlyphVisAttr(..)                        ,
    noGlyphVisAttr                          ,


 -- * Properties
-- ** IsClusterStart
    glyphVisAttrReadIsClusterStart          ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks

newtype GlyphVisAttr = GlyphVisAttr (ForeignPtr GlyphVisAttr)
noGlyphVisAttr :: Maybe GlyphVisAttr
noGlyphVisAttr = Nothing

glyphVisAttrReadIsClusterStart :: GlyphVisAttr -> IO Word32
glyphVisAttrReadIsClusterStart s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO Word32
    return val


