
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

The #PangoIncludedModule structure for a statically linked module
contains the functions that would otherwise be loaded from a dynamically
loaded module.
-}

module GI.Pango.Structs.IncludedModule
    ( 

-- * Exported types
    IncludedModule(..)                      ,
    noIncludedModule                        ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks

newtype IncludedModule = IncludedModule (ForeignPtr IncludedModule)
noIncludedModule :: Maybe IncludedModule
noIncludedModule = Nothing

-- XXX Skipped getter for "IncludedModule:list" :: Not implemented: "Wrapping foreign callbacks is not supported yet"

-- XXX Skipped getter for "IncludedModule:init" :: Not implemented: "Wrapping foreign callbacks is not supported yet"

-- XXX Skipped getter for "IncludedModule:exit" :: Not implemented: "Wrapping foreign callbacks is not supported yet"


